"use strict";
exports.__esModule = true;
var request = require('request');
var cheerio = require('cheerio');
var NfeDownloader = (function () {
    function NfeDownloader() {
        this.newurl = 'a';
    }
    NfeDownloader.prototype.getNfe = function (qrUrl, request_options, callback) {
        var _this = this;
        var nf = '';
        request_options['url'] = qrUrl;
        request(request_options, function (error, response, html) {
            if (!error && response.statusCode == 200) {
                var urlParam = '';
                var $ = cheerio.load(html);
                var content = $('#iframeConteudo').attr('src');
                if (content != '') {
                    request_options['url'] = content;
                    request.get(request_options, function (error, response, html) {
                        if (!error && response.statusCode == 200) {
                            var $ = cheerio.load(html);
                            // faz o parse do retorno do QRCode para adquirir os dados do link para o modelo federal
                            var $ = cheerio.load(html).html().toString();
                            nf = $.substring($.search('function visualizarAbas()') + 26, $.length);
                            nf = nf.substring(0, nf.search('}'));
                            nf = nf.replace('self.location=', 'urlParam = ');
                            eval(nf);
                            //monta a url com os parametros corretos
                            var suppUrl = content.substring(0, content.lastIndexOf('/'));
                            this.newurl = suppUrl + '/' + urlParam;
                            var newurl = suppUrl + '/' + urlParam;
                            request_options['url'] = newurl;
                            getData(request_options);
                        }
                        else if (error) {
                            callback({ 'error': 21, 'content': error });
                            return 0;
                        }
                        else {
                            callback({ 'error': 22, 'content': response });
                            return 0;
                        }
                    });
                }
                else {
                    // faz o parse do retorno do QRCode para adquirir os dados do link para o modelo federal
                    var $ = cheerio.load(html).html().toString();
                    nf = $.substring($.search('function visualizarAbas()') + 26, $.length);
                    nf = nf.substring(0, nf.search('}'));
                    nf = nf.replace('self.location=', 'urlParam = ');
                    eval(nf);
                    //monta a url com os parametros corretos
                    var suppUrl = qrUrl.substring(0, qrUrl.lastIndexOf('/'));
                    _this.newurl = suppUrl + '/' + urlParam;
                    var newurl = suppUrl + '/' + urlParam;
                    request_options['url'] = newurl;
                    getData(request_options);
                }
            }
            else if (error) {
                callback({ 'error': 11, 'content': error });
            }
            else {
                callback({ 'error': 12, 'content': response });
            }
        });
        function getData(request_options) {
            request.get(request_options, function (error, response, html) {
                if (!error && response.statusCode == 200) {
                    var $ = cheerio.load(html, { decodeEntities: false });
                    var tabtitle = $('#botoes_nft li').find('b');
                    var tabtitles_1 = [];
                    tabtitle.each(function (i, el) {
                        tabtitles_1.push(sanitize($(this).text()));
                    });
                    //inicializa as variaveis de suporte e lista final
                    var i = 0;
                    var returnValue = {};
                    var param = {};
                    var flg_coletar = true;
                    //percorre as 11 abas de descrição da NFe
                    tabtitles_1.forEach(function (el, i) {
                        //localiza as abas no html pelo id
                        var box = $('#aba_nft_' + i + ' td');
                        var content = [];
                        if (i == 0) {
                            //reduz os elementos para <td><label>nome do campo</label><span>valor do campo</span></td>
                            box = $('#aba_nft_' + i + ' .titulo-aba ').next().find('td');
                        }
                        else if (i == 3) {
                            //normaliza a aba de descrição dos produtos diferentemente das outras abas
                            var labels = [];
                            //insere na lista labels o index dos labels da lista .toggle
                            box = $('#aba_nft_' + i).find('table.prod-serv-header').first().find('td');
                            box.each(function (i, el) {
                                labels.push(sanitize($(this).children('label').text()));
                            });
                            var n = 0;
                            var ncompare = 0;
                            var prodstr = '{';
                            var comprstr = '';
                            var flg = true;
                            //insere o conteudo do .toggle na lista items
                            box = $('#aba_nft_' + i).find('table.toggle td');
                            box.each(function (i, el) {
                                switch (i % 5) {
                                    //Subdivide a rotina em multiplos de 5 (quantidades de itens na seleção da box)
                                    case 0: {
                                        if (i != 0) {
                                            prodstr = prodstr.substr(0, prodstr.length - 2);
                                            prodstr = prodstr + '}, {';
                                        }
                                        ncompare = 0;
                                    }
                                    //adiciona o item no json(string atualmente) do produto
                                    default: {
                                        prodstr = prodstr + '"' + labels[ncompare].replace('\'', '') + '":"' + sanitize($(this).text()) + '", ';
                                    }
                                }
                                ncompare++;
                                //finaliza o item
                                if (i == box.length - 1) {
                                    comprstr = '[' + prodstr.substr(0, prodstr.length - 2) + '}]';
                                }
                                n = i;
                            });
                            //adiciona os itens em uma variavel JSON
                            var comprasJSON = JSON.parse(comprstr);
                            ncompare = 0;
                            var flag_collect = true;
                            //insere o conteudo restante
                            box = $('#aba_nft_' + i).find('table.toggable td');
                            box.each(function (i, el) {
                                var p = sanitize($(this).children('label').text());
                                var v = sanitize($(this).children('span').text());
                                //para o caso onde a box possue 3 chindren (não descreve um novo item)
                                if (!flag_collect && $(this).children().length == 3) {
                                    ncompare++;
                                    flag_collect = true;
                                }
                                //descreve um item e adiciona na json[posição relativa do item][chave] = valor
                                if ($(this).children().length == 2 && flag_collect) {
                                    var aux = comprasJSON[ncompare][p.replace("[/']", '')] = v;
                                    //proximo item
                                }
                                else if ($(this).children().length == 1) {
                                    flag_collect = false;
                                }
                            });
                            //adiciona os itens de compras descritos na variavel json de retorno
                            returnValue[el] = comprasJSON;
                        }
                        else if (i == 6) {
                            //normaliza a aba de descrição dos produtos diferentemente das outras abas
                            var labels = [];
                            var pagamentos = {};
                            //insere na lista labels o index dos labels da lista
                            box = $('#aba_nft_' + i).find('table').find('tr');
                            var flg = true;
                            box.each(function (i1, el) {
                                $(this).find('td').each(function (i2, el) {
                                    if (flg) {
                                        labels.push(sanitize($(this).children('label').text()));
                                    }
                                    else {
                                        pagamentos[labels[i2]] = sanitize($(this).children('span').text());
                                    }
                                });
                                flg = false;
                            });
                            returnValue[el] = pagamentos;
                            flg_coletar = false;
                        }
                        else if (i >= 7) {
                            //abas não colecionaveis
                            flg_coletar = false;
                        }
                        //percorre as abas normalizadas e coletas os dados
                        if (i != 3 && flg_coletar) {
                            param = {};
                            box.each(function (i, el) {
                                var p = sanitize($(this).children('label').text());
                                var v = sanitize($(this).children('span').text());
                                param[p.replace("[']", "")] = v;
                            });
                            returnValue[el] = param;
                        }
                        flg_coletar = true;
                    });
                    callback(returnValue);
                }
                else if (error) {
                    callback({ 'error': 31, 'content': error });
                }
                else {
                    callback({ 'error': 32, 'content': response });
                }
            }); // end_request
        } // end_getData
        function sanitize(str) {
            return str.trim().replace(/\s\s+/g, ' ');
        }
    }; // end_getNfe
    return NfeDownloader;
}()); // end_export
exports.NfeDownloader = NfeDownloader;
